@use '../core';

// Grid placeholder to generate a column of elements. This should be used as
// the default style for a grid variant, with an override for the breakpoints
%grid {
  display: grid;
  grid-template-columns: 1fr;
}

.-grid {
  // Two even responsive columns.
  &-2 {
    @extend %grid;

    @include core.respond-to('medium-up') {
      grid-template-columns: 1fr 1fr;
    }
  }

  // Three even responsive columns.
  &-3 {
    @extend %grid;

    @include core.respond-to('medium-up') {
      grid-template-columns: 1fr 1fr 1fr;
    }
  }

  // Four even responsive columns, that degrades to 2 on "small" screens
  &-4 {
    @include core.respond-to('small-up') {
      display: grid;
      grid-template-columns: 1fr 1fr;
    }

    @include core.respond-to('large-up') {
      grid-template-columns: 1fr 1fr 1fr 1fr;
    }
  }

  // 1/3 and 2/3 responsive columns
  &-1-2 {
    @extend %grid;

    @include core.respond-to('medium-up') {
      grid-template-columns: 1fr 2fr;
    }
  }

  // 2/3 and 1/3 responsive columns
  &-2-1 {
    @extend %grid;

    @include core.respond-to('medium-up') {
      grid-template-columns: 2fr 1fr;
    }
  }

  // 1/5 and 4/5 responsive columns
  &-1-4 {
    @extend %grid;

    @include core.respond-to('medium-up') {
      grid-template-columns: 1fr 4fr;
    }
  }

  // Variant: Adds a gap on a grid
  &--gap {
    grid-gap: var(--spacer-default);

    @include core.respond-to('small') {
      > *:not(:last-child) {
        margin-bottom: var(--spacer-default);
      }
    }
  }
}
